DUMP(8)

NAME
dump - filesystem backup

SYNOPSIS
dump [-0123456789acknu] [-B records] [-b blocksize] [-d density] [-f file] [-h level] [-s feet] [-T date] filesystem
dump [-W | -w]

(The 4.3BSD option syntax is implemented for backward compatibility, but is not documented here.)

DESCRIPTION
Dump examines files on a filesystem and determines which files need to be backed up. These files are copied to the given disk, tape or other storage medium for safe keeping (see the -f option below for doing remote backups). A dump that is larger than the output medium is broken into multiple volumes. On most media the size is determined by writing until an end-of-media indication is returned. This can be enforced by using the -a option.

On media that cannot reliably return an end-of-media indication (such as some cartridge tape drives) each volume is of a fixed size; the actual size is determined by the tape size and density and/or block count options below. By default, the same output file name is used for each volume after prompting the operator to change media.

The following options are supported by dump:

-0-9
    Dump levels. A level 0, full backup, guarantees the entire file system is copied (but see also the -h option below). A level number above 0, incremental backup, tells dump to copy all files new or modified since the last dump of the same or lower level. The default level is 9.

-B records
    The number of dump records per volume. This option overrides the calculation of tape size based on length and density.

-a  “auto-size”. Bypass all tape length considerations, and enforce writing until an end-of-media indication is returned. This fits best for most modern tape drives. Use of this option is particularly recommended when appending to an existing tape, or using a tape drive with hardware compression (where you can never be sure about the compression ratio).

-b blocksize
    The number of kilobytes per dump record.

-c  Change the defaults for use with a cartridge tape drive, with a density of 8000 bpi, and a length of 1700 feet.

-h level
    Honor the user “nodump” flag only for dumps at or above the given level. The default honor level is 1, so that incremental backups omit such files but full backups retain them.

-d density
    Set tape density to density. The default is 1600BPI.

-f file
    Write the backup to file; file may be a special device file like /dev/rst0 (a tape drive), /dev/rfd1 (a floppy disk drive), an ordinary file, or ‘-’ (the standard output). Multiple file names may be given as a single argument separated by commas. Each file will be used for one dump volume in the order listed; if the dump requires more volumes than the number of names given, the last file name will used for all remaining volumes after prompting for media changes. If the name of the file is of the form “host:file”, or “user@host:file”, dump writes to the named file on the remote host using rmt(8). The default path name of the remote rmt(8) program is /etc/rmt; this can be overridden by the environment variable RMT.

-k  Use Kerberos authentication to talk to remote tape servers. (Only available if this option was enabled when dump was compiled.)

-n  Whenever dump requires operator attention, notify all operators in the group “operator” by means similar to a wall(1).

-s feet
    Attempt to calculate the amount of tape needed at a particular density. If this amount is exceeded, dump prompts for a new tape. It is recommended to be a bit conservative on this option. The default tape length is 2300 feet.

-T date
    Use the specified date as the starting time for the dump instead of the time determined from looking in /etc/dumpdates. The format of date is the same as that of ctime(3). This option is useful for automated dump scripts that wish to dump over a specific period of time. The -T option is mutually exclusive from the -u option.

-u  Update the file /etc/dumpdates after a successful dump. The format of /etc/dumpdates is readable by people, consisting of one free format record per line: filesystem name, increment level and ctime(3) format dump date. There may be only one entry per filesystem at each level. The file /etc/dumpdates may be edited to change any of the fields, if necessary.

-W  Dump tells the operator what file systems need to be dumped. This information is gleaned from the files /etc/dumpdates and /etc/fstab. The -W option causes dump to print out, for each file system in /etc/dumpdates the most recent dump date and level, and highlights those file systems that should be dumped. If the -W option is set, all other options are ignored, and dump exits immediately.

-w  Is like W, but prints only those filesystems which need to be dumped.

Dump requires operator intervention on these conditions: end of tape, end of dump, tape write error, tape open error or disk read error (if there are more than a threshold of 32). In addition to alerting all operators implied by the -n key, dump interacts with the operator on dump's control terminal at times when dump can no longer proceed, or if something is grossly wrong. All questions dump poses must be answered by typing “yes” or “no”, appropriately.

Since making a dump involves a lot of time and effort for full dumps, dump checkpoints itself at the start of each tape volume. If writing that volume fails for some reason, dump will, with operator permission, restart itself from the checkpoint after the old tape has been rewound and removed, and a new tape has been mounted.

Dump tells the operator what is going on at periodic intervals, including usually low estimates of the number of blocks to write, the number of tapes it will take, the time to completion, and the time to the tape change. The output is verbose, so that others know that the terminal controlling dump is busy, and will be for some time.

In the event of a catastrophic disk event, the time required to restore all the necessary backup tapes or files to disk can be kept to a minimum by staggering the incremental dumps. An efficient method of staggering incremental dumps to minimize the number of tapes follows:

•   Always start with a level 0 backup, for example:

        /sbin/dump -0u -f /dev/nrst0 /usr/src

    This should be done at set intervals, say once a month or once every two months, and on a set of fresh tapes that is saved forever.

•   After a level 0, dumps of active file systems are taken on a daily basis, using a modified Tower of Hanoi algorithm, with this sequence of dump levels:

        3 2 5 4 7 6 9 8 9 9 ...

    For the daily dumps, it should be possible to use a fixed number of tapes for each day, used on a weekly basis. Each week, a level 1 dump is taken, and the daily Hanoi sequence repeats beginning with 3. For weekly dumps, another fixed set of tapes per dumped file system is used, also on a cyclical basis.

After several months or so, the daily and weekly tapes should get rotated out of the dump cycle and fresh tapes brought in.

ENVIRONMENT
The environment variable RMT will be used to determine the pathname of the remote rmt(8) program.

FILES
/dev/rst0
    default tape unit to dump to
/etc/dumpdates
    dump date records
/etc/fstab
    dump table: file systems and frequency
/etc/group
    to find group operator

SEE ALSO
dump(5), fstab(5), ft(8), restore(8), rmt(8)

DIAGNOSTICS
Many, and verbose.

Dump exits with zero status on success. Startup errors are indicated with an exit code of 1; abnormal termination is indicated with an exit code of 3.

BUGS
Fewer than 32 read errors on the filesystem are ignored.

Each reel requires a new process, so parent processes for reels already written just hang around until the entire tape is written.

Currently, physio(9) slices all requests into chunks of 64 KB. Therefore, it is impossible to use a larger tape blocksize, so dump will prevent this from happening.

Dump with the -W or -w options does not report filesystems that have never been recorded in /etc/dumpdates, even if listed in /etc/fstab.

It would be nice if dump knew about the dump sequence, kept track of the tapes scribbled on, told the operator which tape to mount when, and provided more assistance for the operator running restore.

dump cannot do remote backups without being run as root, due to its security history. This will be fixed in a later version of FreeBSD. Presently, it work if you set it setuid (like it used to be), but this might constitute a security risk.

HISTORY
A dump command appeared in AT&T UNIX.